"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var throttle_debounce_1 = require("throttle-debounce");
var utils_1 = require("./utils");
/**
 * Viewport component allow tracking the component when it appears in the viewport
 */
var Viewport = /** @class */ (function (_super) {
    __extends(Viewport, _super);
    function Viewport(props) {
        var _this = _super.call(this, props) || this;
        _this.screenRef = React.createRef();
        _this.handleScroll = function () {
            var size = _this.getWidthHeight();
            var rect = _this.screenRef.current.getBoundingClientRect();
            if (_this.isInScreen(size, rect)) {
                if (!_this.isEntered && _this.props.onEnter) {
                    _this.enterCount++;
                    _this.props.onEnter(_this.enterCount);
                    _this.isEntered = true;
                    _this.isLeft = false;
                    /*
                     * Only start the auto track when it is in the `fit` mode
                     */
                    _this.props.type === 'fit' && _this.startCounter();
                }
            }
            else if (_this.isEntered && !_this.isLeft && _this.props.onLeave) {
                _this.leaveCount++;
                _this.props.onLeave(_this.leaveCount);
                _this.isLeft = true;
                _this.isEntered = false;
                _this.resetCounter();
            }
        };
        _this.enterCount = 0;
        _this.focusCount = 0;
        _this.isEntered = false;
        _this.leaveCount = 0;
        _this.isLeft = false;
        var func = {
            fit: utils_1.isFittedIn,
            overlap: utils_1.isOverlapping
        };
        _this.isInScreen = func[_this.props.type];
        return _this;
    }
    Viewport.prototype.componentDidMount = function () {
        window.addEventListener('scroll', throttle_debounce_1.throttle(this.props.delay, this.handleScroll), {
            passive: true
        });
    };
    Viewport.prototype.componentWillUnmount = function () {
        window.removeEventListener('scroll', this.handleScroll);
        this.resetCounter();
    };
    Viewport.prototype.render = function () {
        return (React.createElement("div", { className: this.props.className, id: this.props.id, ref: this.screenRef }, this.props.children));
    };
    Viewport.prototype.getWidthHeight = function () {
        var height = window.innerHeight || document.documentElement.clientHeight;
        var width = window.innerWidth || document.documentElement.clientWidth;
        return { width: width, height: height };
    };
    Viewport.prototype.startCounter = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.props.autoTrack === false)
                            return [2 /*return*/];
                        if (!(this.props.waitToStartAutoTrack > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.sleep()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        this.counter = window.setInterval(function () {
                            _this.focusCount++;
                        }, 1000);
                        return [2 /*return*/];
                }
            });
        });
    };
    Viewport.prototype.resetCounter = function () {
        if (!this.props.autoTrack)
            return;
        if (this.props.onFocusOut) {
            this.props.onFocusOut(this.focusCount);
        }
        clearInterval(this.counter);
        this.focusCount = 0;
    };
    Viewport.prototype.sleep = function () {
        var _this = this;
        return new Promise(function (resolve) { return setTimeout(resolve, _this.props.waitToStartAutoTrack * 1000); });
    };
    Viewport.defaultProps = {
        type: 'fit',
        delay: 100,
        autoTrack: false
    };
    return Viewport;
}(React.Component));
exports.Viewport = Viewport;
